//
//  ViewController.m
//  UIAnimation
//
//  Created by Christopher on 9/7/15.
//  Copyright (c) 2015 Christopher. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [super viewDidLoad];
    myView = [[UIView alloc]initWithFrame:CGRectMake(60, 150, 200, 200)];
    myView.backgroundColor = [UIColor cyanColor];
    [self.view addSubview:myView];
    
    UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    [button setTitle:@"Change" forState:UIControlStateNormal];
    button.frame = CGRectMake(130, 40, 60, 40);
    [button addTarget:self action:@selector(startAnimation)
     forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:button];
    
    myView.layer.backgroundColor = [UIColor grayColor].CGColor;
    myView.layer.cornerRadius = 20.0f;
    
    CALayer *sublayer =[CALayer layer];
    sublayer.backgroundColor =[UIColor blueColor].CGColor;
    sublayer.shadowOffset = CGSizeMake(0, 3);
    sublayer.shadowRadius =5.0;
    sublayer.shadowColor =[UIColor blackColor].CGColor;
    sublayer.shadowOpacity =0.8;
    sublayer.frame = CGRectMake(60, 150, 200, 200);
    sublayer.borderColor =[UIColor blackColor].CGColor;
    sublayer.borderWidth =2.0;
    sublayer.cornerRadius =10.0;
    [self.view.layer addSublayer:sublayer];
    
    CALayer *imageLayer =[CALayer layer];
    imageLayer.frame = sublayer.bounds;
    imageLayer.cornerRadius =10.0;
    imageLayer.contents =(id)[UIImage
                              imageNamed:@"us.jpg"].CGImage;
    imageLayer.masksToBounds =NO;
    [sublayer addSublayer:imageLayer];
    
    CABasicAnimation *fader = [CABasicAnimation animationWithKeyPath:@"opacity"];
    [fader setDuration:3.0];
    [fader setFromValue:[NSNumber numberWithFloat:0.0]];
    [imageLayer addAnimation:fader forKey:@"Fade"];
    
    CABasicAnimation *spin = [CABasicAnimation animationWithKeyPath:@"transform.rotation"];
    [spin setToValue:[NSNumber numberWithFloat:M_PI * 2.0]];
    [spin setDuration:3.0];
    [imageLayer addAnimation:spin forKey:@"spinAnimation"];


}

- (void)startAnimation
{
    [UIView beginAnimations:@"animation1" context:nil];
    [UIView setAnimationDuration:2.0f];
    [UIView setAnimationDelegate:self];
    [UIView setAnimationDidStopSelector:@selector(StopAnimation)];

    CGRect myFrame = myView.frame;
    
    myFrame.origin.y = 300;
    myView.frame = myFrame;
    myView.alpha = 0;
    myView.transform = CGAffineTransformScale(myView.transform,
                                              0.5, 0.5);
    myView.transform = CGAffineTransformIdentity;

    [UIView commitAnimations];
}

- (void)StopAnimation
{
    [UIView beginAnimations:@"animation2" context:nil];
    [UIView setAnimationDuration:2.0f];
    CGRect myFrame = myView.frame;
    myFrame.origin.y = 150;
    myView.backgroundColor = [UIColor redColor];
    myView.frame = myFrame;
    myView.alpha = 1;
    [UIView commitAnimations];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
